/*
;;tdbf.hpp
;;
;;  Include file to use TBCursor, TBDatabase, TBEngine, TBRecord,
;;    TQuery
;;
*/

#ifdef    I_TDBF
#else
#define   I_TDBF

#include  <kdbf.h>

#include  <tbcursor.hpp>
#include  <tbdataba.hpp>
#include  <tbengine.hpp>
#include  <tbrecord.hpp>

#include  <tquery.hpp>
#include  <utils.hpp>

/*
;;class
;;TTdbfExc
;;
;;  Exception object thrown by all tdbf exceptions (incl. TUtil)
;;
;;    string  aliasName;  //Alias name (if available)
;;    string  className;  //Class name (Tutil, TBEngine, etc.)
;;    string  errMsg;     //Error message
;;    string  fldName;    //Field name (if available)
;;    string  fnName;     //Caller function in which error occurred
;;    Retcode lastError;  //IDAPI error code (if available)
;;    string  errInfo;    //Error message aux. info
;;    string  tblName;    //Table name (if available)
*/
class
TTdbfExc
{
  public:
    string  aliasName;  //Alias name (if available)
    string  className;  //Class name (Tutil, TBEngine, etc.)
    string  errMsg;     //Error message
    string  fldName;    //Field name (if available)
    string  fnName;     //Caller function in which error occurred
    Retcode lastError;  //IDAPI error code (if available)
    string  errInfo;    //Error message aux. info
    string  tblName;    //Table name (if available)
};

#endif//I_TDBF

