/*
;;utils.hpp
;;
;;  General utilities, including kdbf- and tdbf- related ones
;;
*/

#ifdef		I_TUTIL
#else
#define 	I_TUTIL

#if 0
#include  <envdef.h> //KDBF include file for BTimeStamp
#else
#include  <tdbf.hpp>
#endif//0

#include  <cstring.h>
#include  <errno.h>
#include  <time.h>

#include  <stdcpp.hpp>


#define   knBufSizTimestamp 24 + 1

/*
;;class
;;TUtil
;;
;;	Fully-static class (no instantiation needed, call all functions using
;;		TUtil:: prefix)
;;
*/
class
TUtil
{
	public:
    static int        ChDir( const char* psPath );
    static TBoolean   CnvStrToUnix( const char* psdTime, long& rdTime );

    static TBoolean   CnvTimestampToUnix( BTimeStamp* pdTimestamp, long& rdTime );

    static TBoolean   CnvTimestrToSec( const char* psdTime, long& rdTime );

    static TBoolean   CnvTimeToBTime( const char* psTime, BTime& rBTime );

    static TBoolean   CnvUnixToStr( long dTime, char* psTime );

    static int        GetCWD( char* ps, int nBufLen );

		static char*	    GetDateTime( int hours = 0, int minutes = 0,
                                   int seconds = 0, time_t external_time = 0 );

    static long       GetTimeFromMidnight();

    static TBoolean   IsValidPath( const char* path );

		static int 		    LookUp( char*, char** );

    static void       MakePath( const char* psFrom, char* psTo );

    static TBoolean   SetDriveAndCwd( const char* psPath );

    static void       ThrowExc( const char* fnArg,
                                const char* errArg = NULL,
                                const char* infoArg = NULL,
                                const char* classArg = NULL,
                                Retcode     lastErrorArg = 0x7FFF,
                                const char* aliasArg = NULL,
                                const char* tblArg = NULL,
                                const char* fldArg = NULL );

	private:
		static char		sDateTimeString[ 80 ];
};

#endif//I_TUTIL

