/*
;;tbrecord.cpp
;;
*/

#pragma   hdrstop

//#include  <strstrea.h> //DBG
//#include  <tbrecord.hpp>
#include  <tdbf.hpp>

/*
;;TBRecord::TBRecord(TBCursor *cursor = 0)
;;  : BRecord( cursor )
;;
*/
TBRecord::TBRecord(TBCursor *cursor)
  : BRecord( cursor ),
    csr( cursor )
{
  if ( DBIERR_NONE != lastError )
  {
    throwExc( "TBRecord()", "BRecord constructor" );
  }
}

/*
;;virtual
;;TBRecord::~TBRecord()
;;
;;  Destructor; will close the record buffer associated with the record.
;;
*/
TBRecord::~TBRecord()
{
}

Retcode
TBRecord::attach( BCursor *curArg )
{
  return ( BRecord::attach( curArg ) );
}

Retcode
TBRecord::attach( TBCursor *curArg )
{
  csr = curArg;
  BRecord::attach( curArg );
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "attach()" );
  }
  return ( lastError );
}

/*
;;Retcode
;;TBRecord::checkExc()
;;
;;  Check if lastError is not DBIERR_NONE, throw (Retcode) exception to app
;;    if so, otherwise return DBIERR_NONE
;;
*/
Retcode
TBRecord::checkExc()
{
#if 0//950520
  if ( DBIERR_NONE != lastError ) //? Any error
  {
    throw ( lastError );          //Then throw to app
  }
  return ( lastError );           //(Always DBIERR_NONE)
#else
  return ( lastError );           //Any error or DBIERR_NONE
#endif//950520
}

/*
;;Retcode
;;TBRecord::closeBlob(FIELDNUMBER fldnbr,
;;                    BOOL bAccept = TRUE)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::closeBlob(FIELDNUMBER fldnbr,
          BOOL bAccept)
{
  BRecord::closeBlob( fldnbr, bAccept );
  switch ( lastError )
  {
    case DBIERR_BLOBNOTOPENED :
    //case PXERR_BLOBNOTOPEN : //951114
      return ( lastError );
    default :
      break;
  }
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "closeBlob()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::closeBlob(const char* psFldName,
;;                    BOOL bAccept = TRUE)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::closeBlob(const char* psFldName,
                    BOOL bAccept )
{
  BRecord::closeBlob( psFldName, bAccept );
  switch ( lastError )
  {
    case DBIERR_BLOBNOTOPENED :
    //case PXERR_BLOBNOTOPEN : //951114
      return ( lastError );
    default :
      break;
  }
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "closeBlob()", NULL, NULL, psFldName );
  }
  return ( lastError );
#endif//950520
}

//extern strstream* winout; //DBG

/*
;;Retcode
;;TBRecord::copyToSimilar( TBRecord* ptRecDest )
;;
;;  Copy same-named fields only, whatever their position or type in dest.
;;
;;  Throws (Retcode) exception on error
;;
*/
Retcode
TBRecord::copyToSimilar( TBRecord* ptRecDest )
{
  FIELDNUMBER h;
  FIELDNUMBER h1;
  FIELDNUMBER nFields = getFieldCount();
  char* ps = new char[ 8192 + 1 ];
  FieldDesc tFldDesc;
  //
  ptRecDest->clear();
  for ( h = 1; nFields >= h; h++ )
  {

    if ( DBIERR_NONE != getFieldDesc( h, tFldDesc ) )
    {
      delete [] ps;
      throw ( lastError );
    }
    if ( tFldDesc.fldType == fldBlob && tFldDesc.fldSubtype != fldstMemo )
    {
      continue; //Not supported type to read (should chk to write also!)
    }
    getField( h, ps, 8192 + 1 ); //Throws exc if > 8K blob
    if ( bLastNull ) //? NULL value for this field
    {
      continue;
    }
    h1 = ptRecDest->getFieldNumber( tFldDesc.fldName );
    if ( 0 == h1 )
    {
      continue;
    }
    ptRecDest->putField( h1, ps );
  }
  delete [] ps;
  return ( DBIERR_NONE );
}

/*
;;Retcode
;;TBRecord::dropBlob(FIELDNUMBER fldnbr)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::dropBlob(FIELDNUMBER fldnbr)
{
  BRecord::dropBlob( fldnbr );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "dropBlob()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::dropBlob(const char* psFldName)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::dropBlob(const char* psFldName)
{
  BRecord::dropBlob( psFldName );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "dropBlob()", NULL, NULL, psFldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getBlobHeader(FIELDNUMBER fldnbr,
;;                        int nSize,
;;                        void* pvBuffer,
;;                        int& rnBytesRead)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getBlobHeader(FIELDNUMBER fldnbr,
                        int nSize,
                        void* pvBuffer,
                        int& rnBytesRead)
{
  BRecord::getBlobHeader( fldnbr, nSize, pvBuffer, rnBytesRead );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getBlobHeader()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getBlobHeader(const char* psFldName,
;;                        int nSize,
;;                        void* pvBuffer,
;;                        int& rnBytesRead)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getBlobHeader(const char* psFldName,
                        int nSize,
                        void* pvBuffer,
                        int& rnBytesRead)
{
  BRecord::getBlobHeader( psFldName, nSize, pvBuffer, rnBytesRead );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getBlobHeader()", NULL, NULL, psFldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;unsigned long
;;TBRecord::getBlobSize(FIELDNUMBER fldnbr)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
unsigned long
TBRecord::getBlobSize(FIELDNUMBER fldnbr)
{
  unsigned long n;
  //
  n = BRecord::getBlobSize( fldnbr );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getBlobSize()" );
  }
#endif//950520
  return ( n );
}

/*
;;unsigned long
;;TBRecord::getBlobSize(const char* psFldName)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
unsigned long
TBRecord::getBlobSize(const char* psFldName)
{
  unsigned long n;
  //
  n = BRecord::getBlobSize( psFldName );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getBlobSize()", NULL, NULL, psFldName );
  }
#endif//950520
  return ( n );
}

/*
;;Retcode
;;TBRecord::getBlob(FIELDNUMBER fldnbr,
;;                  unsigned int nSize,
;;                  long nOffset,
;;                  void far *pvBuffer)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getBlob(FIELDNUMBER fldnbr,
                  unsigned int nSize,
                  long nOffset,
                  void far *pvBuffer)
{
  BRecord::getBlob( fldnbr, nSize, nOffset, pvBuffer );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getBlob()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getBlob(const char* psFldName,
;;                  unsigned int nSize,
;;                  long nOffset,
;;                  void far *pvBuffer)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getBlob(const char* psFldName,
                  unsigned int nSize,
                  long nOffset,
                  void far *pvBuffer)
{
  BRecord::getBlob( psFldName, nSize, nOffset, pvBuffer );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getBlob()", NULL, NULL, psFldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField( FIELDNUMBER fldnbr, char *buf,
;;                    int bufLen )
;;
;;  Note timestamp field types are returned formatted as follows:
;;    hh:mm:ss, mm/dd/yyyy
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, char *buf,
                             int bufLen )
{
  BRecord::getField( fldnbr, buf, bufLen, bLastNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, void *buf,
;;                   int bufLen )
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, void *buf,
                             int bufLen )
{
  BRecord::getField( fldnbr, buf, bufLen, bLastNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, double& val );
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, double& val )
{
  BRecord::getField( fldnbr, val, bLastNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, INT16& val )
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, INT16& val )
{
  BRecord::getField( fldnbr, val, bLastNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, INT32& val )
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, INT32& val )
{
  BRecord::getField( fldnbr, val, bLastNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, UINT16& val )
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, UINT16& val )
{
  BRecord::getField( fldnbr, val, bLastNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, UINT32& val )
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, UINT32& val )
{
  BRecord::getField( fldnbr, val, bLastNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, FMTBcd& val )
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, FMTBcd& val )
{
  BRecord::getField( fldnbr, val, bLastNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, BDate& val )
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, BDate& val )
{
  BRecord::getField( fldnbr, val, bLastNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, BTime& val )
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, BTime& val )
{
  BRecord::getField( fldnbr, val, bLastNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, BTimeStamp& val )
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, BTimeStamp& val )
{
  BRecord::getField( fldnbr, val, bLastNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, char *buf,
;;                             int bufLen, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, char *buf,
                             int bufLen, BOOL& fNull)
{
  BRecord::getField( fldnbr, buf, bufLen, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, void *buf,
;;                             int bufLen, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, void *buf,
                             int bufLen, BOOL& fNull)
{
  BRecord::getField( fldnbr, buf, bufLen, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, double& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, double& val, BOOL& fNull)
{
  BRecord::getField( fldnbr, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, INT16& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, INT16& val, BOOL& fNull)
{
  BRecord::getField( fldnbr, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, INT32& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, INT32& val, BOOL& fNull)
{
  BRecord::getField( fldnbr, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, UINT16& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, UINT16& val, BOOL& fNull)
{
  BRecord::getField( fldnbr, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, UINT32& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, UINT32& val, BOOL& fNull)
{
  BRecord::getField( fldnbr, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, FMTBcd& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, FMTBcd& val, BOOL& fNull)
{
  BRecord::getField( fldnbr, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, BDate& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, BDate& val, BOOL& fNull)
{
  BRecord::getField( fldnbr, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, BTime& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, BTime& val, BOOL& fNull)
{
  BRecord::getField( fldnbr, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(FIELDNUMBER fldnbr, BTimeStamp& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(FIELDNUMBER fldnbr, BTimeStamp& val, BOOL& fNull)
{
  BRecord::getField( fldnbr, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(char *fldName, char *buf, int bufLen,
;;                               BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(char *fldName, char *buf, int bufLen,
                               BOOL& fNull)
{
  BRecord::getField( fldName, buf, bufLen, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(char *fldName, void *buf, int bufLen,
;;                               BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(char *fldName, void *buf, int bufLen,
                               BOOL& fNull)
{
  BRecord::getField( fldName, buf, bufLen, fNull ); 
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(char *fldName, double& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(char *fldName, double& val, BOOL& fNull)
{
  BRecord::getField( fldName, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(char *fldName, INT16& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(char *fldName, INT16& val, BOOL& fNull)
{
  BRecord::getField( fldName, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(char *fldName, INT32& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(char *fldName, INT32& val, BOOL& fNull)
{
  BRecord::getField( fldName, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(char *fldName, UINT16& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(char *fldName, UINT16& val, BOOL& fNull)
{
  BRecord::getField( fldName, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(char *fldName, UINT32& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(char *fldName, UINT32& val, BOOL& fNull)
{
  BRecord::getField( fldName, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(char *fldName, FMTBcd& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(char *fldName, FMTBcd& val, BOOL& fNull)
{
  BRecord::getField( fldName, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(char *fldName, BDate& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(char *fldName, BDate& val, BOOL& fNull)
{
  BRecord::getField( fldName, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(char *fldName, BTime& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(char *fldName, BTime& val, BOOL& fNull)
{
  BRecord::getField( fldName, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(char *fldName, BTimeStamp& val, BOOL& fNull)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(char *fldName, BTimeStamp& val, BOOL& fNull)
{
  BRecord::getField( fldName, val, fNull );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(const char *fldName, char *buf, int bufLen )
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(const char *fldName, char *buf, int bufLen )
{
  BRecord::getField( fldName, buf, bufLen );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(const char *fldName, void *buf, int bufLen )
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(const char *fldName, void *buf, int bufLen )
{
  BRecord::getField( fldName, buf, bufLen );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(const char *fldName, double& val )
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(const char *fldName, double& val )
{
  BRecord::getField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(const char *fldName, INT16& val )
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(const char *fldName, INT16& val )
{
  BRecord::getField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(const char *fldName, INT32& val )
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(const char *fldName, INT32& val )
{
  BRecord::getField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(const char *fldName, UINT16& val )
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(const char *fldName, UINT16& val )
{
  BRecord::getField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(const char *fldName, UINT32& val )
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(const char *fldName, UINT32& val )
{
  BRecord::getField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(const char *fldName, FMTBcd& val )
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(const char *fldName, FMTBcd& val )
{
  BRecord::getField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(const char *fldName, BDate& val )
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(const char *fldName, BDate& val )
{
  BRecord::getField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(const char *fldName, BTime& val )
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(const char *fldName, BTime& val )
{
  BRecord::getField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::getField(const char *fldName, BTimeStamp& val )
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::getField(const char *fldName, BTimeStamp& val )
{
  BRecord::getField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "getField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;BOOL
;;TBRecord::isNull(FIELDNUMBER fldnbr)
;;
*/
BOOL
TBRecord::isNull(FIELDNUMBER fldnbr)
{
  BOOL b;
  //
  b = BRecord::isNull( fldnbr );
#if 0//950520
  checkExc();
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "isNull()" );
  }
#endif//950520
  return ( b );
}

/*
;;TBool
;;TBRecord::isNull(const char *fldname)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
BOOL
TBRecord::isNull(const char *fldname)
{
  BOOL b;
  //
  b = BRecord::isNull( fldname );
#if 0//950520
  checkExc();
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "isNull()", NULL, NULL, fldname );
  }
#endif//950520
  return ( b );
}

/*
;;Retcode
;;TBRecord::openBlobRead(FIELDNUMBER fldnbr,
;;                       BOOL usePrivateCopy = FALSE)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::openBlobRead(FIELDNUMBER fldnbr,
                       BOOL usePrivateCopy)
{
  BRecord::openBlobRead( fldnbr, usePrivateCopy );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "openBlobRead()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::openBlobRead(const char* psFldName,
;;                       BOOL usePrivateCopy = FALSE)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::openBlobRead(const char* psFldName,
                       BOOL usePrivateCopy)
{
  BRecord::openBlobRead( psFldName, usePrivateCopy );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "openBlobRead()", NULL, NULL, psFldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::openBlobWrite(FIELDNUMBER fldnbr,
;;                        long nSize,
;;                        BOOL bCopyOld)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::openBlobWrite(FIELDNUMBER fldnbr,
                        long nSize,
                        BOOL bCopyOld)
{
  BRecord::openBlobWrite( fldnbr, nSize, bCopyOld );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "openBlobWrite()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::openBlobWrite(const char* psFldName,
;;                        long nSize,
;;                        BOOL bCopyOld)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::openBlobWrite(const char* psFldName,
                        long nSize,
                        BOOL bCopyOld)
{
  BRecord::openBlobWrite( psFldName, nSize, bCopyOld );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "openBlobWrite()", NULL, NULL, psFldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putBlob(FIELDNUMBER fldnbr,
;;                  unsigned long nSize,
;;                  unsigned long nOffset,
;;                  void far *pvBuffer)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putBlob(FIELDNUMBER fldnbr,
                  unsigned long nSize,
                  unsigned long nOffset,
                  void far *pvBuffer)
{
  BRecord::putBlob( fldnbr, nSize, nOffset, pvBuffer );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putBlob()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putBlob(const char* psFldName,
;;                  unsigned long nSize,
;;                  unsigned long nOffset,
;;                  void far *pvBuffer)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putBlob(const char* psFldName,
                  unsigned long nSize,
                  unsigned long nOffset,
                  void far *pvBuffer)
{
  BRecord::putBlob( psFldName, nSize, nOffset, pvBuffer );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putBlob()", psFldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(FIELDNUMBER fldnbr, const char *buf)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(FIELDNUMBER fldnbr, const char *buf)
{
  BRecord::putField( fldnbr, buf );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(FIELDNUMBER fldnbr, const void *buf)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(FIELDNUMBER fldnbr, const void *buf)
{
  BRecord::putField( fldnbr, buf );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(FIELDNUMBER fldnbr, double val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(FIELDNUMBER fldnbr, double val)
{
  BRecord::putField( fldnbr, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(FIELDNUMBER fldnbr, INT16 val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(FIELDNUMBER fldnbr, INT16 val)
{
  BRecord::putField( fldnbr, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(FIELDNUMBER fldnbr, INT32 val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(FIELDNUMBER fldnbr, INT32 val)
{
  BRecord::putField( fldnbr, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(FIELDNUMBER fldnbr, UINT16 val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(FIELDNUMBER fldnbr, UINT16 val)
{
  BRecord::putField( fldnbr, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(FIELDNUMBER fldnbr, UINT32 val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(FIELDNUMBER fldnbr, UINT32 val)
{
  BRecord::putField( fldnbr, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(FIELDNUMBER fldnbr, FMTBcd val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(FIELDNUMBER fldnbr, FMTBcd val)
{
  BRecord::putField( fldnbr, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(FIELDNUMBER fldnbr, const BDate& val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(FIELDNUMBER fldnbr, const BDate& val)
{
  BRecord::putField( fldnbr, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(FIELDNUMBER fldnbr, const BTime& val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(FIELDNUMBER fldnbr, const BTime& val)
{
  BRecord::putField( fldnbr, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(FIELDNUMBER fldnbr, const BTimeStamp& val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(FIELDNUMBER fldnbr, const BTimeStamp& val)
{
  BRecord::putField( fldnbr, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(char *fldName, const char *buf)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(char *fldName, const char *buf)
{
  BRecord::putField( fldName, buf );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(char *fldName, const void *buf)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(char *fldName, const void *buf)
{
  BRecord::putField( fldName, buf );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(char *fldName, double val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(char *fldName, double val)
{
  BRecord::putField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(char *fldName, INT16 val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(char *fldName, INT16 val)
{
  BRecord::putField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(char *fldName, INT32 val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(char *fldName, INT32 val)
{
  BRecord::putField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(char *fldName, UINT16 val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(char *fldName, UINT16 val)
{
  BRecord::putField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(char *fldName, UINT32 val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(char *fldName, UINT32 val)
{
  BRecord::putField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(char *fldName, FMTBcd val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(char *fldName, FMTBcd val)
{
  BRecord::putField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(char *fldName, const BDate& val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(char *fldName, const BDate& val)
{
  BRecord::putField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(char *fldName, const BTime& val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(char *fldName, const BTime& val)
{
  BRecord::putField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::putField(char *fldName, const BTimeStamp& val)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::putField(char *fldName, const BTimeStamp& val)
{
  BRecord::putField( fldName, val );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "putField()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::setNull(FIELDNUMBER fldnbr)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
;;  For BLOB fields, openBlobWrite() must have been called prior
;;
*/
Retcode
TBRecord::setNull(FIELDNUMBER fldnbr)
{
  BRecord::setNull( fldnbr );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "setNull()" );
  }
  return ( lastError );
#endif//950520
}

/*
;;Retcode
;;TBRecord::setNull(const char *fldName)
;;
;;  Throws a (Retcode) exception on error
;;    (otherwise returns DBIERR_NONE)
;;
*/
Retcode
TBRecord::setNull(const char *fldName)
{
  BRecord::setNull( fldName );
#if 0//950520
  return ( checkExc() );
#else
  if ( DBIERR_NONE != checkExc() )
  {
    throwExc( "setNull()", NULL, NULL, fldName );
  }
  return ( lastError );
#endif//950520
}

/*
;;protected:
;;void
;;TBRecord::throwExc( const char* fnArg,
;;                    const char* errArg = NULL,
;;                    const char* infoArg = NULL,
;;                    const char* fldArg = NULL )
;;
*/
void
TBRecord::throwExc( const char* fnArg,
                    const char* errArg,
                    const char* infoArg,
                    const char* fldArg )
{
  const char* strAlias = NULL;
  const char* strTabname = NULL;
#if 1
  if ( NULL != recH ) //Only if open
  {
#if 1//950520//Causes GPF, trying w/o db->
    strAlias = csr->db->Alias;
#else
    //strAlias = csr->alias.c_str();
#endif//950520
    strTabname = csr->tabname;
  }
#endif//0
  TUtil::ThrowExc( fnArg,
                   errArg,
                   infoArg,
                   "TBRecord",
                   lastError,
                   strAlias,
                   strTabname,
                   fldArg );
}

